package net.t2code.alias.Spigot.config.config;

import com.google.common.base.Preconditions;
import net.t2code.alias.Spigot.Main;
import net.t2code.alias.Util;
import net.t2code.t2codelib.SPIGOT.api.messages.T2Csend;
import net.t2code.t2codelib.SPIGOT.api.messages.T2Ctemplate;
import org.apache.commons.io.FileUtils;
import org.bukkit.Bukkit;
import org.bukkit.configuration.InvalidConfigurationException;
import org.bukkit.configuration.file.YamlConfiguration;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.logging.Level;

public class Convert {
    protected static void convert() {
        File config = new File(Main.getPath(),"");
        if (config.exists()) convertTo4();
    }

    private static void convertTo4() {
        long long1 = System.currentTimeMillis();
        File config = new File(Main.getPath(), "config.yml");
        YamlConfiguration yamlConfiguration = YamlConfiguration.loadConfiguration(config);

        if (yamlConfiguration.get(Config.configVersion.path) == null || ((Integer) Config.configVersion.value) < Util.getConfigVersion() && new File(Main.getPath(), "config.yml").exists()) {
            yamlConfiguration.set("ConfigVersion", null);
            try {
                yamlConfiguration.save(config);
            } catch (IOException e) {
                e.printStackTrace();
            }

            File dir = new File(Main.getPath() + "/languages");
            File newDir = new File(Main.getPath() + "/OldConfig/Version3/languages");
            try {
                FileUtils.moveDirectory(dir, newDir);
            } catch (IOException e) {
                e.printStackTrace();
            }

            File f = new File(Main.getPath() + "/OldConfig/Version3/languages/");
            File[] fileArray = f.listFiles();
            for (File file : fileArray) {
                long long2 = System.currentTimeMillis();
                String sub = file.getName().substring(file.getName().length() - 4);
                if (sub.equals(".yml")) {
                    YamlConfiguration yamlConfigurationOld;
                    try {
                        Preconditions.checkArgument(file != null, "File cannot be null");
                        YamlConfiguration language = new YamlConfiguration();
                        language.load(file);
                        yamlConfigurationOld = language;
                    } catch (FileNotFoundException var3) {
                        continue;
                    } catch (IOException var4) {
                        Bukkit.getLogger().log(Level.SEVERE, "Cannot load " + file, var4);
                        continue;
                    } catch (InvalidConfigurationException var5) {
                        Bukkit.getLogger().log(Level.SEVERE, "Cannot load " + file, var5);
                        continue;
                    }
                    File newFile = new File(Main.getPath(), "languages/" + file.getName().replace("_messages.yml", "") + ".yml");
                    YamlConfiguration yamlConfigurationNew = YamlConfiguration.loadConfiguration(newFile);

                    yamlConfigurationNew.set("plugin.onlyForPlayer", yamlConfigurationOld.getString("Plugin.OnlyForPlayer"));
                    yamlConfigurationNew.set("plugin.aliasDisabled", yamlConfigurationOld.getString("Plugin.AliasDisabled"));
                    yamlConfigurationNew.set("plugin.reload.start", yamlConfigurationOld.getString("Plugin.Reload.Start"));
                    yamlConfigurationNew.set("plugin.reload.end", yamlConfigurationOld.getString("Plugin.Reload.End"));
                    yamlConfigurationNew.set("plugin.noPermissionForCommand", yamlConfigurationOld.getString("Plugin.ForCommand"));
                    yamlConfigurationNew.set("plugin.noSubCommand", yamlConfigurationOld.getString("Plugin.NoSubCommand"));
                    yamlConfigurationNew.set("cost.buy", yamlConfigurationOld.getString("Cost.Buy"));
                    yamlConfigurationNew.set("cost.noMoney", yamlConfigurationOld.getString("Cost.NoMoney"));
                    yamlConfigurationNew.set("cost.confirm.command", yamlConfigurationOld.getString("Cost.BuyConfirm"));
                    yamlConfigurationNew.set("cost.confirm.cancel", yamlConfigurationOld.getString("Cost.BuyCancel"));
                    yamlConfigurationNew.set("cost.confirm.notPossible", yamlConfigurationOld.getString("Cost.BuyConfirmNotPossible"));

                    try {
                        yamlConfigurationNew.save(newFile);
                    } catch (IOException e) {
                        T2Csend.warning(Main.getPlugin(), e.getMessage());
                        e.printStackTrace();
                    }
                    T2Csend.console(Util.getPrefix() + " §2The language file §6(" + newFile.getName() + ") &2was converted to the new config format §7- §e" + (System.currentTimeMillis() - long2) + "ms");
                }
            }
        }
        T2Csend.console(Util.getPrefix() + " §2All files were successfully converted. §7- §e" + (System.currentTimeMillis() - long1) + "ms");
        T2Ctemplate.onLoadSeparateStroke(Util.getPrefix());
    }
}
